/*
     Copyright (C) 2006  Georges Da Costa

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef GOSD_C
typedef void win_t;
#endif

int  gosd_lock_display();
void gosd_release_display();
void gosd_update_display(win_t*);
void gosd_put_background(win_t*);
void gosd_add_button(const unsigned int x, const unsigned int y,
		     const unsigned int w, const unsigned int h,
		     const unsigned int type,
		     void (func)(unsigned int, unsigned int, unsigned int, void *),
		     void *arg,
		     win_t*);
void gosd_loop(void);

void gosd_set_handler(void(*draw_handler)(win_t*, void*), void*, win_t*);

void gosd_init(void);
void gosd_add_timeout(void(*handler)(void*),void*);

win_t *gosd_new_window(const int posx, const int posy,
		       const unsigned int sizex, const unsigned int sizey,
		       const char *name);

void gosd_position(const int posx, const int posy,win_t*);
void gosd_size(const unsigned int w, const unsigned int h, win_t*);

Pixmap gosd_get_buffer(const win_t*);
Window gosd_get_window(const win_t*);
Display *gosd_get_display(void);


/* Fonts */
void gosd_print(win_t* w, const int x, const int y, const unsigned int font, const unsigned int color,
		const char* txt);
unsigned int gosd_text_width(win_t* w, unsigned int font, const char*txt);
unsigned int gosd_text_height(win_t* w, unsigned int font, const char*txt);

void gosd_add_font(win_t* w, const unsigned int index, const double size, const char *name);
void gosd_add_color(win_t* w, const unsigned int index,
		    const unsigned int r, const unsigned int g, const unsigned int b);


