/*
     Copyright (C) 2006  Georges Da Costa

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <signal.h>
#include <unistd.h>

#define FT_FREETYPE_H  <freetype/freetype.h>
#include <X11/Xlib.h>

#include <X11/Xft/Xft.h>

#include <sys/types.h>

#define __USE_XOPEN /* strptime */
#include <time.h>

#include "toolbox.h"

#include "gosd.h"
win_t *w;

#include "calendar.h"

#define SIZEX 196
#define SIZEY 160

unsigned int c1_r=0,c2_r=0;
unsigned int c1_g=0,c2_g=0;
unsigned int c1_b=0,c2_b=0;

unsigned int delta_jours=0;

void handler_calendar(win_t *w, void* data) {
  if(gosd_lock_display() == -1)
    return;
  gosd_put_background(w);

  calendar(w, data);

  gosd_update_display(w);
  gosd_release_display();
}


int main(int argc, char **argv) {
  int posx=0;
  int posy=0;

  void *cal;

  if(argc >= 3) {posx = atoi(argv[1]); posy=atoi(argv[2]); }

  if(argc >= 6) {
    c1_r=atoi(argv[3]);
    c1_g=atoi(argv[4]);
    c1_b=atoi(argv[5]);
  }

  if(argc >= 9) {
    c2_r=atoi(argv[6]);
    c2_g=atoi(argv[7]);
    c2_b=atoi(argv[8]);
  }

  if(argc >= 10) {
    delta_jours=atoi(argv[9]);
  }

  gosd_init();
  w=gosd_new_window(posx, posy, SIZEX, SIZEY, "Light-Calendar");

  gosd_add_color(w, 0, c1_r, c1_g, c1_b);
  gosd_add_color(w, 1, c2_r, c2_g, c2_b);

  gosd_add_font(w, 0, 10,  "sans");
  gosd_add_font(w, 1, 12,  "sans");
  gosd_add_font(w, 2, 16,  "sans");

  cal = new_calendar(w,
		     0, 1, 2,
		     0, 1,
		     delta_jours);

  gosd_add_button(151,    14, 14, 20, 1, prev_month,cal,w);
  gosd_add_button(167, 14, 14, 20, 1, current_month,cal,w);
  gosd_add_button(181, 14, 14, 20, 1, next_month,cal,w);
  gosd_set_handler(handler_calendar, cal, w);

  gosd_loop();

  return 0;
}
